#-------------------------------------------------------------------------------
#-- Copyright (c) 2001 by Trenz Electronic.
#-- Duenner Kirchweg 77, 32257 Buende, Germany, www.trenz-electronic.de
#-------------------------------------------------------------------------------
#-- Project:     TE-XC2S Application Note: SoC with XR16 RISC CPU.
#-- File:        hex2vhd.pl
#-- Description: Perl script to create VHDL files from assembler output.
#-- History:     2001oct05, FB, Created.
#-------------------------------------------------------------------------------

$src= "c:/MyDocs/tt/TE-XC2S/an-XC2S-XR16/prj/firmware/demo.hex";

$dst= $src; $dst=~ s/\.hex$/\.vhd/;
$cc=  $src; $cc=~  s/\.hex$/\.c/;
$tpl1= $src; $tpl1=~ m/(.*)\/.*$/; $tpl1= $1 . "/tpl1.vhd";
$tpl2= $src; $tpl2=~ m/(.*)\/.*$/; $tpl2= $1 . "/tpl2.vhd";
print $tpl1 . "  " . $tpl2;

#---------------------------------------
# read hex file
open(SRC, $src);
	while($line=<SRC>)
	{	chomp($line);
		$line=~ m/- .. .... (.+)/;
		$line= $1;
		$lines= $lines . " " . $line;
	}
close(SRC);

# remove leading, trailing and multiple spaces
$lines=~ s/^ //g;
$lines=~ s/ $//g;
$lines=~ s/  / /g; 

# convert to array and count bytes
@hex= split(/ /, $lines);
$hex= @hex;

print "# of bytes: " . $hex;

#---------------------------------------
# create attribute lines
$idx= 0;

while(@hex)
{	#---
	# version 1: 16bit big-endian BlockRAMs
#	@c= splice(@hex, 0, 32);
#	$attrib= $c[30].$c[31]. $c[28].$c[29]. $c[26].$c[27]. $c[24].$c[25]
#	.        $c[22].$c[23]. $c[20].$c[21]. $c[18].$c[19]. $c[16].$c[17]
#	.        $c[14].$c[15]. $c[12].$c[13]. $c[10].$c[11] .$c[8 ].$c[9 ]
#	.        $c[6 ].$c[7 ]. $c[4 ].$c[5 ]. $c[2 ].$c[3 ]. $c[0 ].$c[1 ];
#	@attrib[$idx]= $attrib;
	#---
	#version 2: 2x 8bit BlockRAMs
	@c= splice(@hex, 0, 64);
	$attrlo= $c[62].$c[60]. $c[58].$c[56]. $c[54].$c[52]. $c[50].$c[48]
	.        $c[46].$c[44]. $c[42].$c[40]. $c[38].$c[36]. $c[34].$c[32]
	.        $c[30].$c[28]. $c[26].$c[24]. $c[22].$c[20] .$c[18].$c[16]
	.        $c[14].$c[12]. $c[10].$c[8 ]. $c[6 ].$c[4 ]. $c[2 ].$c[0 ];
	$attrhi= $c[63].$c[61]. $c[59].$c[57]. $c[55].$c[53]. $c[51].$c[49]
	.        $c[47].$c[45]. $c[43].$c[41]. $c[39].$c[37]. $c[35].$c[33]
	.        $c[31].$c[29]. $c[27].$c[25]. $c[23].$c[21] .$c[19].$c[17]
	.        $c[15].$c[13]. $c[11].$c[9 ]. $c[7 ].$c[5 ]. $c[3 ].$c[1 ];
	@attrib[$idx     ]= $attrlo;
	@attrib[$idx+4*16]= $attrhi;
	#---
	$idx++;
}

$attrib= @attrib;
print "# of INITs: " . $attrib;

#---------------------------------------
# write vhd file

open(DST, ">" . $dst);
open(TPL1, $tpl1);
while($line=<TPL1>)
{	print DST $line;
}
close(TPL1);

open(CC, $cc);
while($line=<CC>)
{	print DST "\t-- " . $line;
}
close(CC);

@name= ("INIT_00 of U0", "INIT_01 of U0", "INIT_02 of U0", "INIT_03 of U0",
        "INIT_04 of U0", "INIT_05 of U0", "INIT_06 of U0", "INIT_07 of U0",
        "INIT_08 of U0", "INIT_09 of U0", "INIT_0A of U0", "INIT_0B of U0",
        "INIT_0C of U0", "INIT_0D of U0", "INIT_0E of U0", "INIT_0F of U0",
		#---
        "INIT_00 of U1", "INIT_01 of U1", "INIT_02 of U1", "INIT_03 of U1",
        "INIT_04 of U1", "INIT_05 of U1", "INIT_06 of U1", "INIT_07 of U1",
        "INIT_08 of U1", "INIT_09 of U1", "INIT_0A of U1", "INIT_0B of U1",
        "INIT_0C of U1", "INIT_0D of U1", "INIT_0E of U1", "INIT_0F of U1",
		#---
        "INIT_00 of U2", "INIT_01 of U2", "INIT_02 of U2", "INIT_03 of U2",
        "INIT_04 of U2", "INIT_05 of U2", "INIT_06 of U2", "INIT_07 of U2",
        "INIT_08 of U2", "INIT_09 of U2", "INIT_0A of U2", "INIT_0B of U2",
        "INIT_0C of U2", "INIT_0D of U2", "INIT_0E of U2", "INIT_0F of U2",
		#---
        "INIT_00 of U3", "INIT_01 of U3", "INIT_02 of U3", "INIT_03 of U3",
        "INIT_04 of U3", "INIT_05 of U3", "INIT_06 of U3", "INIT_07 of U3",
        "INIT_08 of U3", "INIT_09 of U3", "INIT_0A of U3", "INIT_0B of U3",
        "INIT_0C of U3", "INIT_0D of U3", "INIT_0E of U3", "INIT_0F of U3",
		#---
        "INIT_00 of U4", "INIT_01 of U4", "INIT_02 of U4", "INIT_03 of U4",
        "INIT_04 of U4", "INIT_05 of U4", "INIT_06 of U4", "INIT_07 of U4",
        "INIT_08 of U4", "INIT_09 of U4", "INIT_0A of U4", "INIT_0B of U4",
        "INIT_0C of U4", "INIT_0D of U4", "INIT_0E of U4", "INIT_0F of U4",
		#---
        "INIT_00 of U5", "INIT_01 of U5", "INIT_02 of U5", "INIT_03 of U5",
        "INIT_04 of U5", "INIT_05 of U5", "INIT_06 of U5", "INIT_07 of U5",
        "INIT_08 of U5", "INIT_09 of U5", "INIT_0A of U5", "INIT_0B of U5",
        "INIT_0C of U5", "INIT_0D of U5", "INIT_0E of U5", "INIT_0F of U5",
		#---
        "INIT_00 of U6", "INIT_01 of U6", "INIT_02 of U6", "INIT_03 of U6",
        "INIT_04 of U6", "INIT_05 of U6", "INIT_06 of U6", "INIT_07 of U6",
        "INIT_08 of U6", "INIT_09 of U6", "INIT_0A of U6", "INIT_0B of U6",
        "INIT_0C of U6", "INIT_0D of U6", "INIT_0E of U6", "INIT_0F of U6",
		#---
        "INIT_00 of U7", "INIT_01 of U7", "INIT_02 of U7", "INIT_03 of U7",
        "INIT_04 of U7", "INIT_05 of U7", "INIT_06 of U7", "INIT_07 of U7",
        "INIT_08 of U7", "INIT_09 of U7", "INIT_0A of U7", "INIT_0B of U7",
        "INIT_0C of U7", "INIT_0D of U7", "INIT_0E of U7", "INIT_0F of U7");

for($i=0; $i< $attrib; $i++)
{	if ($attrib[$i])
	{	print DST "\tattribute " . $name[$i] . ": label is \"" . $attrib[$i] . "\";\n";
	}
}

open(TPL2, $tpl2);
while($line=<TPL2>)
{	print DST $line;
}
close(TPL1);
close(DST);

#-------------------------------------------------------------------------------
# end of file
